/**
 * Betfair: Exchange Streaming API
 * API to receive streamed updates. This is an ssl socket connection of CRLF delimited json messages (see RequestMessage & ResponseMessage)
 *
 * OpenAPI spec version: 1.0.1423
 * Contact: bdp@betfair.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


package com.betfair.esa.swagger.model;

import com.google.gson.annotations.SerializedName;
import io.swagger.annotations.ApiModelProperty;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;


/**
 * OrderFilter
 */
@javax.annotation.Generated(value = "class io.swagger.codegen.languages.JavaClientCodegen", date = "2020-07-08T14:44:27.518+08:00")
public class OrderFilter   {
  @SerializedName("includeOverallPosition")
  private Boolean includeOverallPosition = null;

  @SerializedName("accountIds")
  private List<Long> accountIds = new ArrayList<Long>();

  @SerializedName("customerStrategyRefs")
  private List<String> customerStrategyRefs = new ArrayList<String>();

  @SerializedName("partitionMatchedByStrategyRef")
  private Boolean partitionMatchedByStrategyRef = null;

  public OrderFilter includeOverallPosition(Boolean includeOverallPosition) {
    this.includeOverallPosition = includeOverallPosition;
    return this;
  }

   /**
   * Returns overall / net position (See: OrderRunnerChange.mb / OrderRunnerChange.ml). Default=true
   * @return includeOverallPosition
  **/
  @ApiModelProperty(example = "null", value = "Returns overall / net position (See: OrderRunnerChange.mb / OrderRunnerChange.ml). Default=true")
  public Boolean getIncludeOverallPosition() {
    return includeOverallPosition;
  }

  public void setIncludeOverallPosition(Boolean includeOverallPosition) {
    this.includeOverallPosition = includeOverallPosition;
  }

  public OrderFilter accountIds(List<Long> accountIds) {
    this.accountIds = accountIds;
    return this;
  }

  public OrderFilter addAccountIdsItem(Long accountIdsItem) {
    this.accountIds.add(accountIdsItem);
    return this;
  }

   /**
   * Internal use only & should not be set on your filter (your subscription is already locked to your account). If set subscription will fail.
   * @return accountIds
  **/
  @ApiModelProperty(example = "null", value = "Internal use only & should not be set on your filter (your subscription is already locked to your account). If set subscription will fail.")
  public List<Long> getAccountIds() {
    return accountIds;
  }

  public void setAccountIds(List<Long> accountIds) {
    this.accountIds = accountIds;
  }

  public OrderFilter customerStrategyRefs(List<String> customerStrategyRefs) {
    this.customerStrategyRefs = customerStrategyRefs;
    return this;
  }

  public OrderFilter addCustomerStrategyRefsItem(String customerStrategyRefsItem) {
    this.customerStrategyRefs.add(customerStrategyRefsItem);
    return this;
  }

   /**
   * Restricts to specified customerStrategyRefs; this will filter orders and StrategyMatchChanges accordingly (Note: overall postition is not filtered)
   * @return customerStrategyRefs
  **/
  @ApiModelProperty(example = "null", value = "Restricts to specified customerStrategyRefs; this will filter orders and StrategyMatchChanges accordingly (Note: overall postition is not filtered)")
  public List<String> getCustomerStrategyRefs() {
    return customerStrategyRefs;
  }

  public void setCustomerStrategyRefs(List<String> customerStrategyRefs) {
    this.customerStrategyRefs = customerStrategyRefs;
  }

  public OrderFilter partitionMatchedByStrategyRef(Boolean partitionMatchedByStrategyRef) {
    this.partitionMatchedByStrategyRef = partitionMatchedByStrategyRef;
    return this;
  }

   /**
   * Returns strategy positions (See: OrderRunnerChange.smc=Map<customerStrategyRef, StrategyMatchChange>) - these are sent in delta format as per overall position. Default=false
   * @return partitionMatchedByStrategyRef
  **/
  @ApiModelProperty(example = "null", value = "Returns strategy positions (See: OrderRunnerChange.smc=Map<customerStrategyRef, StrategyMatchChange>) - these are sent in delta format as per overall position. Default=false")
  public Boolean getPartitionMatchedByStrategyRef() {
    return partitionMatchedByStrategyRef;
  }

  public void setPartitionMatchedByStrategyRef(Boolean partitionMatchedByStrategyRef) {
    this.partitionMatchedByStrategyRef = partitionMatchedByStrategyRef;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    OrderFilter orderFilter = (OrderFilter) o;
    return Objects.equals(this.includeOverallPosition, orderFilter.includeOverallPosition) &&
        Objects.equals(this.accountIds, orderFilter.accountIds) &&
        Objects.equals(this.customerStrategyRefs, orderFilter.customerStrategyRefs) &&
        Objects.equals(this.partitionMatchedByStrategyRef, orderFilter.partitionMatchedByStrategyRef);
  }

  @Override
  public int hashCode() {
    return Objects.hash(includeOverallPosition, accountIds, customerStrategyRefs, partitionMatchedByStrategyRef);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class OrderFilter {\n");
    
    sb.append("    includeOverallPosition: ").append(toIndentedString(includeOverallPosition)).append("\n");
    sb.append("    accountIds: ").append(toIndentedString(accountIds)).append("\n");
    sb.append("    customerStrategyRefs: ").append(toIndentedString(customerStrategyRefs)).append("\n");
    sb.append("    partitionMatchedByStrategyRef: ").append(toIndentedString(partitionMatchedByStrategyRef)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

